//+------------------------------------------------------------------+
//|                                                         SOT.mq4 |
//|                                           Copyright  2013, Dilz |
//|                                          ssoftware2011@gmail.com |
//+------------------------------------------------------------------+

#property copyright "Copyright  2013, Dilz"
#property link      "ssoftware2011@gmail.com"
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_width1 2
#property indicator_color2 Red
#property indicator_width2 2
//+------------------------------------------------------------------+
#include <stdlib.mqh>
#include <stderror.mqh>
//+------------------------------------------------------------------+
#define BAR 4
//+------------------------------------------------------------------+
//| Input Parameters Definition                                      |
//+------------------------------------------------------------------+
extern int  SOTPeriod = 14;
extern int  AvoidArrowAfterCandleInRow = 3;
extern bool ShowAlert = true;
//+------------------------------------------------------------------+
//| Local Parameters Definition                                      |
//+------------------------------------------------------------------+
string lbl = "SOTBreakout";
double up[], dn[];
datetime lastAlert;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
  //------------------------------------------------------------------
  SetIndexStyle(0, DRAW_ARROW); SetIndexBuffer(0, up); SetIndexArrow(0, 233); SetIndexLabel(0, "UP");
  SetIndexStyle(1, DRAW_ARROW); SetIndexBuffer(1, dn); SetIndexArrow(1, 234); SetIndexLabel(1, "DN");
  //------------------------------------------------------------------
  lastAlert = 0;
  //------------------------------------------------------------------
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
  //------------------------------------------------------------------
  //------------------------------------------------------------------
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
  //------------------------------------------------------------------
  int limit;
  int counted_bars = IndicatorCounted();
  if (counted_bars > 0) counted_bars--;
  limit = Bars - counted_bars;
  if (limit > Bars - SOTPeriod - 1) limit = Bars - SOTPeriod - 1;
  //------------------------------------------------------------------
  double sot, gap;
  for (int i = limit - 1; i >= 1; i--)
  {
    sot = 0;
    for (int j = i+1; j < i+SOTPeriod+1; j++)
      sot += (High[j]-Low[j])/Volume[j];
    if (NormalizeDouble((High[i]-Low[i])/Volume[i], Digits+10) >= NormalizeDouble(2*sot/SOTPeriod, Digits+10))
    {
      for (int k = i+1; k < i+AvoidArrowAfterCandleInRow+1; k++)
      {
        if (Close[i] > Open[i] && Close[k] < Open[k]) break;
        if (Close[i] < Open[i] && Close[k] > Open[k]) break;
      }
      if (k < i+AvoidArrowAfterCandleInRow+1)
      {
        gap = 0.5 * iATR(NULL, 0, 10, i);
        if (Close[i] > Open[i]) up[i] = Low[i] - gap;
        if (Close[i] < Open[i]) dn[i] = High[i] + gap;
      }
    }
  }
  //------------------------------------------------------------------
  if (ShowAlert)
    if (lastAlert != Time[0])
    {
      if (up[1] != 0 && up[1] != EMPTY_VALUE)
      {
         lastAlert = Time[0];
         Alert(TimeToStr(Time[0]) + ": " + Symbol() + "(" + GetTimeFrameName(0) + "): SOTBreakout buy signal");
      }
      if (dn[1] != 0 && dn[1] != EMPTY_VALUE)
      {
        lastAlert = Time[0];
        Alert(TimeToStr(Time[0]) + ": " + Symbol() + "(" + GetTimeFrameName(0) + "): SOTBreakout sell signal");
      }
    }
  //------------------------------------------------------------------
  return(0);
}
//+------------------------------------------------------------------+
string GetTimeFrameName(int TimeFrame)
{
  //------------------------------------------------------------------
  switch (TimeFrame)
  {
    case PERIOD_M1: return("M1");
    case PERIOD_M5: return("M5");
    case PERIOD_M15: return("M15");
    case PERIOD_M30: return("M30");
    case PERIOD_H1: return("H1");
    case PERIOD_H4: return("H4");
    case PERIOD_D1: return("D1");
    case PERIOD_W1: return("W1");
    case PERIOD_MN1: return("MN1");
    case 0: return(GetTimeFrameName(Period()));
  }
  //------------------------------------------------------------------
}
//+------------------------------------------------------------------+

